unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, PEEditor;

type
  TForm1 = class(TForm)
    PEEditor1: TPEEditor;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    Label3: TLabel;
    Button1: TButton;
    Button2: TButton;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    ListView1: TListView;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    ListView2: TListView;
    Button6: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
Refreshing:Boolean;
implementation

uses Unit2, Unit3, Unit4, Unit5;

{$R *.DFM}

procedure TForm1.Button4Click(Sender: TObject);
var Li:TListItem;
i:integer;
Section:PSection;
Directory:PDirectory;
begin
if not Refreshing then begin
if not opendialog1.execute then exit;
PEEditor1.PEFilePath:=OpenDialog1.FileName;
if PEEditor1.PEFilePath='' then
begin
MessageBox(self.handle,'You selected not valid PE','ERROR',MB_ICONERROR);
exit;
end;
end;
Refreshing:=false;
Edit1.Text:=InttoHex(PEEditor1.EntryPoint,8);
Edit2.Text:=InttoHex(PEEditor1.ImageBase,8);
Edit3.Text:=InttoHex(PEEditor1.ImageSize,8);
ListView1.Items.BeginUpdate;
ListView1.Items.Clear;
For i:=0 to PEEditor1.SectionList.Count-1 do
begin
Section:=PSection(PEEditor1.SectionList[i]);
Li:=ListView1.Items.add;
Li.Caption:=Section.o_name;
Li.subItems.add(IntToHex(Section.o_rva,8));
Li.subItems.add(IntToHex(Section.o_virtual_size,8));
Li.subItems.add(IntToHex(Section.o_physical_offs,8));
Li.subItems.add(IntToHex(Section.o_physical_size,8));
Li.subItems.add(IntToHex(Section.o_flags,8));
end;
ListView1.Items.EndUpdate;
listview2.Items.BeginUpdate;
listview2.Items.Clear;
with PEEditor1 do begin
Directory:=PDirectory(DirectoryList[0]);
Li:=ListView2.Items.Add;
Li.Caption:='Export table';
Li.SubItems.add(InttoHex(Directory.RVA,8));
Li.SubItems.add(InttoHex(Directory.Size,8));

Directory:=PDirectory(DirectoryList[1]);
Li:=ListView2.Items.Add;
Li.Caption:='Import table';
Li.SubItems.add(InttoHex(Directory.RVA,8));
Li.SubItems.add(InttoHex(Directory.Size,8));

Directory:=PDirectory(DirectoryList[2]);
Li:=ListView2.Items.Add;
Li.Caption:='Resource';
Li.SubItems.add(InttoHex(Directory.RVA,8));
Li.SubItems.add(InttoHex(Directory.Size,8));

Directory:=PDirectory(DirectoryList[3]);
Li:=ListView2.Items.Add;
Li.Caption:='Exception';
Li.SubItems.add(InttoHex(Directory.RVA,8));
Li.SubItems.add(InttoHex(Directory.Size,8));

Directory:=PDirectory(DirectoryList[4]);
Li:=ListView2.Items.Add;
Li.Caption:='Security';
Li.SubItems.add(InttoHex(Directory.RVA,8));
Li.SubItems.add(InttoHex(Directory.Size,8));

Directory:=PDirectory(DirectoryList[5]);
Li:=ListView2.Items.Add;
Li.Caption:='Relocations';
Li.SubItems.add(InttoHex(Directory.RVA,8));
Li.SubItems.add(InttoHex(Directory.Size,8));

Directory:=PDirectory(DirectoryList[6]);
Li:=ListView2.Items.Add;
Li.Caption:='Debug datas';
Li.SubItems.add(InttoHex(Directory.RVA,8));
Li.SubItems.add(InttoHex(Directory.Size,8));

Directory:=PDirectory(DirectoryList[7]);
Li:=ListView2.Items.Add;
Li.Caption:='Description';
Li.SubItems.add(InttoHex(Directory.RVA,8));
Li.SubItems.add(InttoHex(Directory.Size,8));

Directory:=PDirectory(DirectoryList[8]);
Li:=ListView2.Items.Add;
Li.Caption:='Global PTR';
Li.SubItems.add(InttoHex(Directory.RVA,8));
Li.SubItems.add(InttoHex(Directory.Size,8));

Directory:=PDirectory(DirectoryList[9]);
Li:=ListView2.Items.Add;
Li.Caption:='TLS table';
Li.SubItems.add(InttoHex(Directory.RVA,8));
Li.SubItems.add(InttoHex(Directory.Size,8));

Directory:=PDirectory(DirectoryList[10]);
Li:=ListView2.Items.Add;
Li.Caption:='Load config';
Li.SubItems.add(InttoHex(Directory.RVA,8));
Li.SubItems.add(InttoHex(Directory.Size,8));

Directory:=PDirectory(DirectoryList[11]);
Li:=ListView2.Items.Add;
Li.Caption:='Bound import';
Li.SubItems.add(InttoHex(Directory.RVA,8));
Li.SubItems.add(InttoHex(Directory.Size,8));

Directory:=PDirectory(DirectoryList[12]);
Li:=ListView2.Items.Add;
Li.Caption:='Import address table';
Li.SubItems.add(InttoHex(Directory.RVA,8));
Li.SubItems.add(InttoHex(Directory.Size,8));
end;
ListView2.Items.EndUpdate;
GroupBox1.Enabled:=True;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
ExitProcess(0);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
Form2.SHowModal;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
Form3.ShowModal;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
Refreshing:=False;
end;

procedure TForm1.Button6Click(Sender: TObject);
var Directory:PDirectory;
begin
if not Assigned(listview2.selected) then exit;
with peeditor1 do begin
Directory:=PDirectory(DirectoryList[listview2.selected.index]);
Form4.Edit1.text:=InttoHex(Directory.Rva,8);
Form4.Edit2.text:=InttoHex(Directory.Size,8);
Form4.ShowModal;
if Form4.ModalResult=mrOk then
begin
Directory.Rva:=StrToInt64('$'+Form4.Edit1.text);
Directory.Size:=StrToInt64('$'+Form4.Edit2.text);
Refreshing:=True;
RefreshPE;
Button4Click(nil);
end;
end;
end;
procedure TForm1.Button3Click(Sender: TObject);
var Section:PSection;
VAR Z:PCHAR;
begin
if not assigned(listview1.selected) then exit;
section:=peeditor1.SectionList[Listview1.Selected.index];
Form5.Edit1.Text:=section.o_name;
Form5.Edit2.text:=InttoHex(section.o_rva,8);
Form5.Edit3.text:=InttoHex(section.o_virtual_size,8);
Form5.Edit4.Text:=InttoHex(section.o_physical_offs,8);
Form5.Edit5.Text:=InttoHex(section.o_physical_size,8);
Form5.Edit6.Text:=InttoHex(section.o_flags,8);
Form5.SHowmodal;
if form5.modalresult<>mrok then exit;
z:=Pchar(Form5.Edit1.Text);
Move(z^,Section.o_name,8);
section.o_virtual_size:=StrToInt64('$'+Form5.Edit2.Text);
section.o_physical_offs:=StrToInt64('$'+Form5.Edit3.Text);
section.o_physical_size:=StrToInt64('$'+Form5.Edit4.Text);
section.o_virtual_size:=StrToInt64('$'+Form5.Edit5.Text);
section.o_flags:=StrToInt64('$'+Form5.Edit6.Text);
Refreshing:=True;
Button4Click(nil);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
Peeditor1.EntryPoint:=StrToInt64('$'+edit1.text);
Peeditor1.ImageBase:=StrToInt64('$'+edit2.text);
Peeditor1.ImageSize:=StrToInt64('$'+edit3.text);
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
if not SaveDialog1.execute then exit;
peeditor1.Savepe(savedialog1.FileName);
end;

end.
